/**
 *******************************************************************************
 * @file    tmpm37A_dnf.h
 * @brief   This file provides all the functions prototypes for DNF driver.
 * @version V2.0.2.1
 * @date    2015/11/02
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * (C)Copyright TOSHIBA ELECTRONIC DEVICES & STORAGE CORPORATION 2017 All rights reserved
 *******************************************************************************
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __TMPM37A_DNF_H
#define __TMPM37A_DNF_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "TMPM37A.h"
#include "tx03_common.h"


/** @addtogroup TX03_Periph_Driver
  * @{
  */

/** @addtogroup DNF
  * @{
  */

/** @defgroup DNF_Exported_Types
  * @{
  */

/** @} */
/* End of group DNF_Exported_Types */

/** @defgroup DNF_Exported_Constants
  * @{
  */

#define DNF_FILTER_CLK_STOP           ((uint32_t)0x00000000)
#define DNF_FILTER_CLK_FSYS_2         ((uint32_t)0x00000001)
#define DNF_FILTER_CLK_FSYS_4         ((uint32_t)0x00000002)
#define DNF_FILTER_CLK_FSYS_8         ((uint32_t)0x00000003)
#define DNF_FILTER_CLK_FSYS_16        ((uint32_t)0x00000004)
#define DNF_FILTER_CLK_FSYS_32        ((uint32_t)0x00000005)
#define DNF_FILTER_CLK_FSYS_64        ((uint32_t)0x00000006)
#define DNF_FILTER_CLK_FSYS_128       ((uint32_t)0x00000007)

#define IS_DNF_FILTER_CLK(param)      (((param) == DNF_FILTER_CLK_STOP) || \
                                       ((param) == DNF_FILTER_CLK_FSYS_2) || \
                                       ((param) == DNF_FILTER_CLK_FSYS_4) || \
                                       ((param) == DNF_FILTER_CLK_FSYS_8) || \
                                       ((param) == DNF_FILTER_CLK_FSYS_16) || \
                                       ((param) == DNF_FILTER_CLK_FSYS_32) || \
                                       ((param) == DNF_FILTER_CLK_FSYS_64) || \
                                       ((param) == DNF_FILTER_CLK_FSYS_128))

/** @} */
/* End of DNF_Exported_Constants */

/** @defgroup DNF_Exported_FunctionPrototypes
  * @{
  */

    void DNF_SetFilterClk(uint32_t FilterClk);
    uint32_t DNF_GetFilterClk(void);
    void DNF_SetInt6Filter(FunctionalState NewState);
    FunctionalState DNF_GetInt6FilterState(void);
    void DNF_SetInt7Filter(FunctionalState NewState);
    FunctionalState DNF_GetInt7FilterState(void);
    void DNF_SetIntCFilter(FunctionalState NewState);
    FunctionalState DNF_GetIntCFilterState(void);

/** @} */
/* End of DNF_Exported_FunctionPrototypes */

/** @} */
/* End of group DNF */

/** @} */
/* End of group TX03_Periph_Driver */


#ifdef __cplusplus
}
#endif                          /* __cplusplus */
#endif                          /* __TMPM37A_DNF_H */
