/**
 *******************************************************************************
 * @file    tmpm37A_dnf_int.c
 * @brief   all interrupt request functions definition of DNF
 *          for the TOSHIBA 'TMPM37A' Device Series 
 * @version V0.100
 * @date    2015/11/02
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * (C)Copyright TOSHIBA ELECTRONIC DEVICES & STORAGE CORPORATION 2017 All rights reserved
 *******************************************************************************
 */

/* Includes ------------------------------------------------------------------*/
#include "tmpm37A_dnf_int.h"
/* external variables --------------------------------------------------------*/
volatile extern uint32_t Flag;
/* Private functions ---------------------------------------------------------*/

/**
  * @brief  INT7 noise filter interrupt.
  * @param  None
  * @retval None
  */
void INT7_IRQHandler(void)
{
    Flag = 1U;
    NVIC_DisableIRQ(INT7_IRQn);
}

/*********************************** END OF FILE ******************************/
