/** 
 *******************************************************************************
 * @file    tmrb_leadingtimingdisplay.c
 * @brief   the application functions of TMRB_PPG demo for the TOSHIBA
 *          'TMPM37A' Device Series 
 * @version V0.100
 * @date    2015/11/02
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * (C)Copyright TOSHIBA ELECTRONIC DEVICES & STORAGE CORPORATION 2017 All rights reserved
 *******************************************************************************
 */

/* Includes ------------------------------------------------------------------*/
#include "tmrb_leadingtimingdisplay.h"

/**
  * @brief  LeadingTiming Rate to String
  * @param  leadingtiming number
  * @retval LeadingTiming rate string
  */
char *LeadingTimingRateToString(uint8_t num)
{
    static char leadingtiming[18U] = "LeadingTiming:   %";

    switch (num) {
    case 0U:
        leadingtiming[6U] = '1';
        leadingtiming[7U] = '0';
        break;                  /* LeadingTiming: 10% */
    case 1U:
        leadingtiming[6U] = '2';
        leadingtiming[7U] = '5';
        break;                  /* LeadingTiming: 25% */
    case 2U:
        leadingtiming[6U] = '5';
        leadingtiming[7U] = '0';
        break;                  /* LeadingTiming: 50% */
    case 3U:
        leadingtiming[6U] = '7';
        leadingtiming[7U] = '5';
        break;                  /* LeadingTiming: 75% */
    case 4U:
        leadingtiming[6U] = '9';
        leadingtiming[7U] = '0';
        break;                  /* LeadingTiming: 90% */
    default:
        /* Do nothing */
        break;                  /* no other cases */
    }

    return leadingtiming;
}
